{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "88b3ed28",
   "metadata": {},
   "source": [
    "# Дескриптор с комиссией #"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "84b8adbb",
   "metadata": {},
   "source": [
    "Часто при зачислении каких-то средств на счет с нас берут комиссию. Давайте реализуем похожий механизм с помощью дескрипторов. Напишите дескриптор `Value`, который будет использоваться в нашем классе `Account`.\n",
    "\n",
    "```python\n",
    "class Account:\n",
    "    amount = Value()\n",
    "    \n",
    "    def __init__(self, commission):\n",
    "        self.commission = commission\n",
    "```\n",
    "\n",
    "У аккаунта будет атрибут `commission`. Именно эту комиссию и нужно вычитать при присваивании значений в `amount`."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "52c62ed9",
   "metadata": {},
   "outputs": [],
   "source": [
    "from descriptor import Account"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "id": "b297b20c",
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "90.0\n"
     ]
    }
   ],
   "source": [
    "new_account = Account(0.1)\n",
    "new_account.amount = 100\n",
    "\n",
    "print(new_account.amount)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "f0eac97f",
   "metadata": {},
   "source": [
    "Опишите дескриптор в файле."
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.6.8"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
